using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using FooCfgToXml;

namespace UiColumnsInterpreters.ItemInterpreters
{
	public class PlaylistTabsItemInterpreter : IItemInterpreter
	{
		private static readonly Guid sGuid = new Guid("abb72d0d-dbf0-4bba-8c68-3357ebe07a4d");

		public Guid TypeGuid
		{
			get { return sGuid; }
		}
		public string TypeName
		{
			get { return "Playlist tabs"; }
		}

		public void WriteValueToXml(XmlWriter writer, byte[] itemSettings, Dictionary<Guid, IItemInterpreter> itemInterpreters)
		{
			if (itemSettings.Length == 0)
				return;

			MemoryStream reader = new MemoryStream(itemSettings, false);

			writer.WriteStartElement("PlaylistTabs");
			
			writer.WriteStartElement("Item");
			IItemInterpreter itemInterpreter = Utilities.WriteItemTypeToXml(writer, reader, itemInterpreters);
			Utilities.WriteItemSettingsToXml(writer, reader, itemInterpreter, itemInterpreters);
			writer.WriteEndElement(); //Item

			writer.WriteEndElement(); //PlaylistTabs
		}

		public void WriteXmlToValue(Stream writer, XmlElement itemSettings, Dictionary<string, IItemInterpreter> itemInterpreters)
		{
			if (itemSettings.ChildNodes.Count == 0)
				return;

			XmlElement playlistTabs = (XmlElement)itemSettings.FirstChild; //Should be first and only child

			XmlElement childItem = (XmlElement)playlistTabs.SelectSingleNode("Item");
			
			IItemInterpreter itemInterpreter = Utilities.WriteItemTypeToCfg(writer, childItem, itemInterpreters);
			Utilities.WriteItemSettingsToCfg(writer, childItem, itemInterpreter, itemInterpreters);
		}
	}
}
